The Open Group Base Specifications Issue 6
IEEE Std 1003.1, 2004 Edition
Copyright © 2001-2004 The IEEE and The Open Group, All Rights reserved.

#### NAME

> posix_memalign - aligned memory allocation (ADVANCED REALTIME)

#### SYNOPSIS

> ``[ADV] #include <stdlib.h>
> int posix_memalign(void **`memptr`, size_t` alignment`, size_t` size`);``
> `
> `

#### DESCRIPTION

> The posix_memalign() function shall allocate size bytes aligned on a boundary specified by alignment, and shall return a pointer to the allocated memory in memptr. The value of alignment shall be a multiple of sizeof( void *), that is also a power of two. Upon successful completion, the value pointed to by memptr shall be a multiple of alignment.

> [CX] The free() function shall deallocate memory that has previously been allocated by posix_memalign().

#### RETURN VALUE

> Upon successful completion, posix_memalign() shall return zero; otherwise, an error number shall be returned to indicate the error.

#### ERRORS

> The posix_memalign() function shall fail if:

> [EINVAL]
>   The value of the alignment parameter is not a power of two multiple of sizeof( void *).
> [ENOMEM]
>   There is insufficient memory available with the requested alignment.

The following sections are informative.

#### EXAMPLES

> None.

#### APPLICATION USAGE

> The posix_memalign() function is part of the Advisory Information option and need not be provided on all implementations.

#### RATIONALE

> None.

#### FUTURE DIRECTIONS

> None.

#### SEE ALSO

> free(), malloc(), the Base Definitions volume of IEEE Std 1003.1-2001, <stdlib.h>

#### CHANGE HISTORY

> First released in Issue 6. Derived from IEEE Std 1003.1d-1999.

> In the SYNOPSIS, the inclusion of <sys/types.h> is no longer required.

End of informative text.

UNIX ® is a registered Trademark of The Open Group.
POSIX ® is a registered Trademark of The IEEE.
[ Main Index | XBD | XCU | XSH | XRAT ]